Attribute VB_Name = "SubClassing"
Option Explicit

Type POINTAPI
  x As Long
  y As Long
End Type

Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Private Const WM_MOUSEWHEEL As Long = &H20A
Private Const WM_DESTROY = &H2
Private Const GWL_WNDPROC = -4
Private lpPrevWndProc As Long

Sub Hook(ByVal gHW As Long)
  lpPrevWndProc = SetWindowLong(gHW, GWL_WNDPROC, AddressOf WindowProc)
End Sub
    
Sub UnHook(ByVal gHW As Long)
  If lpPrevWndProc Then
    SetWindowLong gHW, GWL_WNDPROC, lpPrevWndProc
    lpPrevWndProc = 0
  End If
End Sub
    
Function WindowProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim zDelta As Long
  Select Case uMsg
    Case WM_DESTROY
      UnHook hWnd
      
    Case WM_MOUSEWHEEL
        zDelta = (wParam \ 65535) Mod 65535
        If zDelta < 0 Then
            Call frmMain.ZoomIn((Int(((frmMain.hScr.Value + frmMain.picpreview.Width / 2)) / (TileW * zoom))), (Int(((frmMain.vScr.Value + frmMain.picpreview.Height / 2)) / (TileH * zoom))))
        Else
            Call frmMain.ZoomOut((Int(((frmMain.hScr.Value + frmMain.picpreview.Width / 2)) / (TileW * zoom))), (Int(((frmMain.vScr.Value + frmMain.picpreview.Height / 2)) / (TileH * zoom))))
        End If
        
    Case Else
      WindowProc = CallWindowProc(lpPrevWndProc, hWnd, uMsg, wParam, lParam)
  End Select
End Function
